Ruby: ext/zlib/zlib-1.2.13/deflate.c File Reference

Ruby 3.0.5p211 (2022-11-24 revision ba5cf0f7c52d4d35cc6a173c89eda98ceffa2dcf)

Data Structures | Macros | Typedefs | Enumerations | Functions | Variables
deflate.c File Reference
`#include "deflate.h"`

Go to the source code of this file.

## Data Structures
struct | config_s

## Macros
#define | NIL 0
#define | TOO_FAR 4096
#define | RANK(f) (((f) * 2) - ((f) > 4 ? 9 : 0))
#define | UPDATE_HASH(s, h, c) (h = (((h) << s->hash_shift) ^ (c)) & s->hash_mask)
#define | INSERT_STRING(s, str, match_head)
#define | CLEAR_HASH(s)
#define | HCRC_UPDATE(beg)
#define | check_match(s, start, match, length)
#define | FLUSH_BLOCK_ONLY(s, last)
#define | FLUSH_BLOCK(s, last)
#define | MAX_STORED 65535
#define | MIN(a, b) ((a) > (b) ? (b) : (a))

## Typedefs
typedef block_state compress_func | OF((deflate_state *s, int flush))
| Addition for GDAL : START. More...
typedef struct config_s | config

## Enumerations
enum | block_state { need_more , block_done , finish_started , finish_done }

## Functions
int deflateStateCheck | OF ((z_streamp strm))
void slide_hash | OF ((deflate_state *s))
void putShortMSB | OF ((deflate_state *s, uInt b))
unsigned read_buf | OF ((z_streamp strm, Bytef *buf, unsigned size))
uInt longest_match | OF ((deflate_state *s, IPos cur_match))
void | slide_hash (deflate_state *s)
int ZEXPORT | deflateInit_ (z_streamp strm, int level, const char *version, int stream_size)
int ZEXPORT | deflateInit2_ (z_streamp strm, int level, int method, int windowBits, int memLevel, int strategy, const char *version, int stream_size)
int | deflateStateCheck (z_streamp strm)
int ZEXPORT | deflateSetDictionary (z_streamp strm, const Bytef *dictionary, uInt dictLength)
int ZEXPORT | deflateGetDictionary (z_streamp strm, Bytef *dictionary, uInt *dictLength)
int ZEXPORT | deflateResetKeep (z_streamp strm)
int ZEXPORT | deflateReset (z_streamp strm)
int ZEXPORT | deflateSetHeader (z_streamp strm, gz_headerp head)
int ZEXPORT | deflatePending (z_streamp strm, unsigned *pending, int *bits)
int ZEXPORT | deflatePrime (z_streamp strm, int bits, int value)
int ZEXPORT | deflateParams (z_streamp strm, int level, int strategy)
int ZEXPORT | deflateTune (z_streamp strm, int good_length, int max_lazy, int nice_length, int max_chain)
uLong ZEXPORT | deflateBound (z_streamp strm, uLong sourceLen)
void | putShortMSB (deflate_state *s, uInt b)
void | flush_pending (z_streamp strm)
int ZEXPORT | deflate (z_streamp strm, int flush)
int ZEXPORT | deflateEnd (z_streamp strm)
int ZEXPORT | deflateCopy (z_streamp dest, z_streamp source)
unsigned | read_buf (z_streamp strm, Bytef *buf, unsigned size)
void | lm_init (deflate_state *s)
uInt | longest_match (deflate_state *s, IPos cur_match)
void | fill_window (deflate_state *s)
block_state | deflate_stored (deflate_state *s, int flush)
block_state | deflate_fast (deflate_state *s, int flush)
block_state | deflate_slow (deflate_state *s, int flush)
block_state | deflate_rle (deflate_state *s, int flush)
block_state | deflate_huff (deflate_state *s, int flush)

## Variables
const char | deflate_copyright []
const config | configuration_table [10]

## Macro Definition Documentation

## ◆ check_match

#define check_match | ( |  | s,
|  |  | start,
|  |  | match,
|  |  | length
| ) |  |

Definition at line 1514 of file deflate.c.

## ◆ CLEAR_HASH

#define CLEAR_HASH | ( |  | s | ) |

Value:
do { \
s->head[s->hash_size - 1] = NIL; \
zmemzero((Bytef *)s->head, \
(unsigned)(s->hash_size - 1)*sizeof(*s->head)); \
} while (0)
NIL
#define NIL
Definition: deflate.c:101
Bytef
Byte FAR Bytef
Definition: zconf.h:406

Definition at line 186 of file deflate.c.

## ◆ FLUSH_BLOCK

#define FLUSH_BLOCK | ( |  | s,
|  |  | last
| ) |  |

Value:
{ \
FLUSH_BLOCK_ONLY(s, last); \
if (s->strm->avail_out == 0) return (last) ? finish_started : need_more; \
}
finish_started
@ finish_started
Definition: deflate.c:69
need_more
@ need_more
Definition: deflate.c:67
last
unsigned int last
Definition: nkf.c:4324

Definition at line 1664 of file deflate.c.

## ◆ FLUSH_BLOCK_ONLY

#define FLUSH_BLOCK_ONLY | ( |  | s,
|  |  | last
| ) |  |

Value:
{ \
_tr_flush_block(s, (s->block_start >= 0L ? \
(charf *)&s->window[(unsigned)s->block_start] : \
(charf *)Z_NULL), \
(ulg)((long)s->strstart - s->block_start), \
(last)); \
s->block_start = s->strstart; \
flush_pending(s->strm); \
Tracev((stderr,"[FLUSH]")); \
}
L
#define L(x)
Definition: asm.h:125
charf
char FAR charf
Definition: zconf.h:408
Z_NULL
#define Z_NULL
Definition: zlib.h:212
ulg
unsigned long ulg
Definition: zutil.h:43

Definition at line 1652 of file deflate.c.

## ◆ HCRC_UPDATE

#define HCRC_UPDATE | ( |  | beg | ) |

Value:
do { \
if (s->gzhead->hcrc && s->pending > (beg)) \
strm->adler = crc32(strm->adler, s->pending_buf + (beg), \
s->pending - (beg)); \
} while (0)
crc32
unsigned long ZEXPORT crc32(unsigned long crc, const unsigned char FAR *buf, uInt len)
Definition: crc32.c:1072

Definition at line 807 of file deflate.c.

## ◆ INSERT_STRING

#define INSERT_STRING | ( |  | s,
|  |  | str,
|  |  | match_head
| ) |  |

Value:
(UPDATE_HASH(s, s->ins_h, s->window[(str) + (MIN_MATCH-1)]), \
match_head = s->prev[(str) & s->w_mask] = s->head[s->ins_h], \
s->head[s->ins_h] = (Pos)(str))
UPDATE_HASH
#define UPDATE_HASH(s, h, c)
Definition: deflate.c:157
Pos
ush Pos
Definition: deflate.h:92
str
char str[HTML_ESCAPE_MAX_LEN+1]
Definition: escape.c:18
MIN_MATCH
#define MIN_MATCH
Definition: zutil.h:84

Definition at line 176 of file deflate.c.

## ◆ MAX_STORED

#define MAX_STORED 65535

Definition at line 1670 of file deflate.c.

## ◆ MIN

#define MIN | ( |  | a,
|  |  | b
| ) |  | ((a) > (b) ? (b) : (a))

Definition at line 1673 of file deflate.c.

## ◆ NIL

#define NIL 0

Definition at line 101 of file deflate.c.

## ◆ RANK

#define RANK | ( |  | f | ) | (((f) * 2) - ((f) > 4 ? 9 : 0))

Definition at line 149 of file deflate.c.

## ◆ TOO_FAR

#define TOO_FAR 4096

Definition at line 105 of file deflate.c.

## ◆ UPDATE_HASH

#define UPDATE_HASH | ( |  | s,
|  |  | h,
|  |  | c
| ) |  | (h = (((h) << s->hash_shift) ^ (c)) & s->hash_mask)

Definition at line 157 of file deflate.c.

## Typedef Documentation

## ◆ config

typedef struct config_s config

## ◆ OF

ZEXTERN uLong ZEXPORT crc32_combine64 OF

Addition for GDAL : START.

Addition for GDAL : END.

Definition at line 73 of file deflate.c.

## Enumeration Type Documentation

## ◆ block_state

enum block_state

Enumerator
need_more |
block_done |
finish_started |
finish_done |

Definition at line 66 of file deflate.c.

## Function Documentation

## ◆ deflate()

int ZEXPORT deflate | ( | z_streamp | strm,
|  | int | flush
| ) |  |

Definition at line 815 of file deflate.c.

References _tr_align(), _tr_stored_block(), adler32(), block_done, internal_state::block_start, BUSY_STATE, CLEAR_HASH, COMMENT_STATE, configuration_table, crc32(), deflate_huff(), deflate_rle(), deflate_stored(), deflateStateCheck(), ERR_RETURN, EXTRA_STATE, finish_done, finish_started, FINISH_STATE, flush_pending(), config_s::func, internal_state::gzhead, internal_state::gzindex, GZIP_STATE, HCRC_STATE, HCRC_UPDATE, INIT_STATE, internal_state::insert, L, internal_state::last_flush, internal_state::level, internal_state::lookahead, NAME_STATE, need_more, OS_CODE, internal_state::pending, internal_state::pending_buf, internal_state::pending_buf_size, PRESET_DICT, put_byte, putShortMSB(), RANK, internal_state::status, internal_state::strategy, internal_state::strm, internal_state::strstart, internal_state::w_bits, internal_state::wrap, Z_BLOCK, Z_BUF_ERROR, Z_DEFLATED, Z_FINISH, Z_FULL_FLUSH, Z_HUFFMAN_ONLY, Z_NO_FLUSH, Z_NULL, Z_OK, Z_PARTIAL_FLUSH, Z_RLE, Z_STREAM_END, Z_STREAM_ERROR, and zmemcpy.

Referenced by compress2(), def(), deflateParams(), gz_comp(), gztack(), log_compress(), main(), partcompress(), recompress(), zipCloseFileInZipRaw64(), and zipWriteInFileInZip().

## ◆ deflate_fast()

block_state deflate_fast | ( | deflate_state * | s,
|  | int | flush
| ) |  |

Definition at line 1877 of file deflate.c.

References _tr_tally_dist, _tr_tally_lit, block_done, check_match, fill_window(), finish_done, FLUSH_BLOCK, INSERT_STRING, longest_match(), MAX_DIST, MIN_LOOKAHEAD, MIN_MATCH, need_more, NIL, Tracevv, UPDATE_HASH, Z_FINISH, and Z_NO_FLUSH.

## ◆ deflate_huff()

block_state deflate_huff | ( | deflate_state * | s,
|  | int | flush
| ) |  |

Definition at line 2184 of file deflate.c.

References _tr_tally_lit, block_done, fill_window(), finish_done, FLUSH_BLOCK, need_more, Tracevv, Z_FINISH, and Z_NO_FLUSH.

Referenced by deflate().

## ◆ deflate_rle()

block_state deflate_rle | ( | deflate_state * | s,
|  | int | flush
| ) |  |

Definition at line 2110 of file deflate.c.

References _tr_tally_dist, _tr_tally_lit, Assert, block_done, check_match, fill_window(), finish_done, FLUSH_BLOCK, MAX_MATCH, MIN_MATCH, need_more, internal_state::prev, Tracevv, internal_state::window, Z_FINISH, and Z_NO_FLUSH.

Referenced by deflate().

## ◆ deflate_slow()

block_state deflate_slow | ( | deflate_state * | s,
|  | int | flush
| ) |  |

Definition at line 1979 of file deflate.c.

References _tr_tally_dist, _tr_tally_lit, Assert, block_done, check_match, fill_window(), finish_done, FLUSH_BLOCK, FLUSH_BLOCK_ONLY, INSERT_STRING, longest_match(), MAX_DIST, MIN_LOOKAHEAD, MIN_MATCH, need_more, NIL, TOO_FAR, Tracevv, Z_FILTERED, Z_FINISH, and Z_NO_FLUSH.

## ◆ deflate_stored()

block_state deflate_stored | ( | deflate_state * | s,
|  | int | flush
| ) |  |

Definition at line 1690 of file deflate.c.

References _tr_stored_block(), block_done, finish_done, finish_started, flush_pending(), if(), L, last, len, MAX_STORED, MIN, need_more, read_buf(), Z_FINISH, Z_NO_FLUSH, and zmemcpy.

Referenced by deflate().

## ◆ deflateBound()

uLong ZEXPORT deflateBound | ( | z_streamp | strm,
|  | uLong | sourceLen
| ) |  |

Definition at line 696 of file deflate.c.

References deflateStateCheck(), internal_state::gzhead, internal_state::hash_bits, str, internal_state::strm, internal_state::strstart, internal_state::w_bits, internal_state::wrap, and Z_NULL.

## ◆ deflateCopy()

int ZEXPORT deflateCopy | ( | z_streamp | dest,
|  | z_streamp | source
| ) |  |

Definition at line 1156 of file deflate.c.

References internal_state::bl_desc, internal_state::bl_tree, internal_state::d_desc, deflateEnd(), deflateStateCheck(), internal_state::dyn_dtree, internal_state::dyn_ltree, tree_desc_s::dyn_tree, FAR, internal_state::hash_size, internal_state::head, internal_state::l_desc, internal_state::lit_bufsize, internal_state::pending_buf, internal_state::pending_buf_size, internal_state::pending_out, internal_state::prev, internal_state::strm, internal_state::sym_buf, internal_state::w_size, internal_state::window, Z_MEM_ERROR, Z_NULL, Z_OK, Z_STREAM_ERROR, ZALLOC, and zmemcpy.

## ◆ deflateEnd()

int ZEXPORT deflateEnd | ( | z_streamp | strm | ) |

Definition at line 1130 of file deflate.c.

References BUSY_STATE, deflateStateCheck(), internal_state::status, internal_state::strm, TRY_FREE, Z_DATA_ERROR, Z_NULL, Z_OK, Z_STREAM_ERROR, and ZFREE.

Referenced by compress2(), def(), deflateCopy(), deflateInit2_(), gzclose_w(), gztack(), log_compress(), main(), and zipCloseFileInZipRaw64().

## ◆ deflateGetDictionary()

int ZEXPORT deflateGetDictionary | ( | z_streamp | strm,
|  | Bytef * | dictionary,
|  | uInt * | dictLength
| ) |  |

Definition at line 481 of file deflate.c.

References deflateStateCheck(), len, internal_state::lookahead, internal_state::strm, internal_state::strstart, internal_state::w_size, internal_state::window, Z_NULL, Z_OK, Z_STREAM_ERROR, and zmemcpy.

## ◆ deflateInit2_()

int ZEXPORT deflateInit2_ | ( | z_streamp | strm,
|  | int | level,
|  | int | method,
|  | int | windowBits,
|  | int | memLevel,
|  | int | strategy,
|  | const char * | version,
|  | int | stream_size
| ) |  |

Definition at line 237 of file deflate.c.

References deflateEnd(), deflateReset(), ERR_MSG, FAR, FINISH_STATE, internal_state::gzhead, internal_state::hash_bits, internal_state::hash_mask, internal_state::hash_shift, internal_state::hash_size, internal_state::head, internal_state::high_water, if(), INIT_STATE, internal_state::level, internal_state::lit_bufsize, MAX_MEM_LEVEL, internal_state::method, MIN_MATCH, internal_state::pending_buf, internal_state::pending_buf_size, internal_state::prev, internal_state::status, internal_state::strategy, internal_state::strm, internal_state::sym_buf, internal_state::sym_end, internal_state::w_bits, internal_state::w_mask, internal_state::w_size, internal_state::window, internal_state::wrap, Z_DEFAULT_COMPRESSION, Z_DEFLATED, Z_FIXED, Z_MEM_ERROR, Z_NULL, Z_STREAM_ERROR, Z_VERSION_ERROR, ZALLOC, zcalloc(), zcfree(), and ZLIB_VERSION.

Referenced by deflateInit_().

## ◆ deflateInit_()

int ZEXPORT deflateInit_ | ( | z_streamp | strm,
|  | int | level,
|  | const char * | version,
|  | int | stream_size
| ) |  |

Definition at line 225 of file deflate.c.

References DEF_MEM_LEVEL, deflateInit2_(), MAX_WBITS, Z_DEFAULT_STRATEGY, and Z_DEFLATED.

## ◆ deflateParams()

int ZEXPORT deflateParams | ( | z_streamp | strm,
|  | int | level,
|  | int | strategy
| ) |  |

Definition at line 605 of file deflate.c.

References internal_state::block_start, CLEAR_HASH, configuration_table, deflate(), deflateStateCheck(), err, config_s::func, config_s::good_length, internal_state::good_match, internal_state::last_flush, internal_state::level, internal_state::lookahead, internal_state::matches, config_s::max_chain, internal_state::max_chain_length, config_s::max_lazy, internal_state::max_lazy_match, config_s::nice_length, internal_state::nice_match, slide_hash(), internal_state::strategy, internal_state::strm, internal_state::strstart, Z_BLOCK, Z_BUF_ERROR, Z_DEFAULT_COMPRESSION, Z_FIXED, Z_OK, and Z_STREAM_ERROR.

Referenced by gzsetparams().

## ◆ deflatePending()

int ZEXPORT deflatePending | ( | z_streamp | strm,
|  | unsigned * | pending,
|  | int * | bits
| ) |  |

Definition at line 564 of file deflate.c.

References bits(), deflateStateCheck(), internal_state::pending, internal_state::strm, Z_NULL, Z_OK, and Z_STREAM_ERROR.

## ◆ deflatePrime()

int ZEXPORT deflatePrime | ( | z_streamp | strm,
|  | int | bits,
|  | int | value
| ) |  |

Definition at line 578 of file deflate.c.

References _tr_flush_bits(), internal_state::bi_buf, internal_state::bi_valid, bits(), Buf_size, deflateStateCheck(), internal_state::pending_out, internal_state::strm, internal_state::sym_buf, Z_BUF_ERROR, Z_OK, and Z_STREAM_ERROR.

Referenced by gzscan(), and log_compress().

## ◆ deflateReset()

int ZEXPORT deflateReset | ( | z_streamp | strm | ) |

Definition at line 541 of file deflate.c.

References deflateResetKeep(), lm_init(), internal_state::strm, and Z_OK.

Referenced by deflateInit2_(), gz_comp(), and main().

## ◆ deflateResetKeep()

int ZEXPORT deflateResetKeep | ( | z_streamp | strm | ) |

Definition at line 503 of file deflate.c.

References _tr_init(), adler32(), crc32(), deflateStateCheck(), GZIP_STATE, if(), INIT_STATE, L, internal_state::last_flush, internal_state::pending, internal_state::pending_buf, internal_state::pending_out, internal_state::status, internal_state::strm, internal_state::wrap, Z_NULL, Z_OK, Z_STREAM_ERROR, and Z_UNKNOWN.

Referenced by deflateReset().

## ◆ deflateSetDictionary()

int ZEXPORT deflateSetDictionary | ( | z_streamp | strm,
|  | const Bytef * | dictionary,
|  | uInt | dictLength
| ) |  |

Definition at line 412 of file deflate.c.

References adler32(), internal_state::block_start, CLEAR_HASH, deflateStateCheck(), fill_window(), internal_state::head, INIT_STATE, internal_state::ins_h, internal_state::insert, L, long(), internal_state::lookahead, internal_state::match_available, internal_state::match_length, MIN_MATCH, internal_state::prev, internal_state::prev_length, internal_state::status, str, internal_state::strm, internal_state::strstart, UPDATE_HASH, internal_state::w_mask, internal_state::w_size, internal_state::window, internal_state::wrap, z_const, Z_NULL, Z_OK, and Z_STREAM_ERROR.

Referenced by gzscan(), and log_compress().

## ◆ deflateSetHeader()

int ZEXPORT deflateSetHeader | ( | z_streamp | strm,
|  | gz_headerp | head
| ) |  |

Definition at line 553 of file deflate.c.

References deflateStateCheck(), internal_state::head, internal_state::strm, Z_OK, and Z_STREAM_ERROR.

## ◆ deflateStateCheck()

int deflateStateCheck | ( | z_streamp | strm | ) |

Definition at line 389 of file deflate.c.

References BUSY_STATE, COMMENT_STATE, EXTRA_STATE, FINISH_STATE, GZIP, GZIP_STATE, HCRC_STATE, INIT_STATE, NAME_STATE, internal_state::status, internal_state::strm, and Z_NULL.

Referenced by deflate(), deflateBound(), deflateCopy(), deflateEnd(), deflateGetDictionary(), deflateParams(), deflatePending(), deflatePrime(), deflateResetKeep(), deflateSetDictionary(), deflateSetHeader(), and deflateTune().

## ◆ deflateTune()

int ZEXPORT deflateTune | ( | z_streamp | strm,
|  | int | good_length,
|  | int | max_lazy,
|  | int | nice_length,
|  | int | max_chain
| ) |  |

Definition at line 654 of file deflate.c.

References deflateStateCheck(), internal_state::good_match, internal_state::max_chain_length, internal_state::max_lazy_match, internal_state::nice_match, internal_state::strm, Z_OK, and Z_STREAM_ERROR.

## ◆ fill_window()

void fill_window | ( | deflate_state * | s | ) |

Definition at line 1527 of file deflate.c.

References Assert, if(), long(), MAX_DIST, MIN_LOOKAHEAD, MIN_MATCH, read_buf(), slide_hash(), str, UPDATE_HASH, internal_state::w_size, WIN_INIT, zmemcpy, and zmemzero.

Referenced by deflate_fast(), deflate_huff(), deflate_rle(), deflate_slow(), and deflateSetDictionary().

## ◆ flush_pending()

void flush_pending | ( | z_streamp | strm | ) |

Definition at line 782 of file deflate.c.

References _tr_flush_bits(), len, internal_state::pending, internal_state::pending_buf, internal_state::pending_out, internal_state::strm, and zmemcpy.

Referenced by deflate(), and deflate_stored().

## ◆ lm_init()

void lm_init | ( | deflate_state * | s | ) |

Definition at line 1245 of file deflate.c.

References CLEAR_HASH, configuration_table, config_s::good_length, L, config_s::max_chain, config_s::max_lazy, MIN_MATCH, config_s::nice_length, and internal_state::window_size.

Referenced by deflateReset().

## ◆ longest_match()

uInt longest_match | ( | deflate_state * | s,
|  | IPos | cur_match
| ) |  |

Definition at line 1278 of file deflate.c.

References Assert, int(), len, match, internal_state::max_chain_length, MAX_DIST, MAX_MATCH, MIN_LOOKAHEAD, internal_state::nice_match, NIL, internal_state::prev, strstart, and internal_state::window.

Referenced by deflate_fast(), and deflate_slow().

## ◆ OF() [1/5]

void slide_hash OF | ( | (deflate_state *s) |  | ) |

## ◆ OF() [2/5]

uInt longest_match OF | ( | (deflate_state *s, IPos cur_match) |  | ) |

## ◆ OF() [3/5]

void putShortMSB OF | ( | (deflate_state *s, uInt b) |  | ) |

## ◆ OF() [4/5]

int deflateStateCheck OF | ( | (z_streamp strm) |  | ) |

## ◆ OF() [5/5]

unsigned read_buf OF | ( | (z_streamp strm, Bytef *buf, unsigned size) |  | ) |

## ◆ putShortMSB()

void putShortMSB | ( | deflate_state * | s,
|  | uInt | b
| ) |  |

Definition at line 768 of file deflate.c.

References put_byte.

Referenced by deflate().

## ◆ read_buf()

unsigned read_buf | ( | z_streamp | strm,
|  | Bytef * | buf,
|  | unsigned | size
| ) |  |

Definition at line 1215 of file deflate.c.

References adler32(), crc32(), len, internal_state::strm, and zmemcpy.

Referenced by deflate_stored(), and fill_window().

## ◆ slide_hash()

void slide_hash | ( | deflate_state * | s | ) |

Definition at line 198 of file deflate.c.

References NIL, and internal_state::w_size.

Referenced by deflateParams(), and fill_window().

## Variable Documentation

## ◆ configuration_table

const config configuration_table[10]

Initial value:
= {
{0, 0, 0, 0, deflate_stored},
{4, 4, 8, 4, deflate_fast},
{4, 5, 16, 8, deflate_fast},
{4, 6, 32, 32, deflate_fast},
{4, 4, 16, 16, deflate_slow},
{8, 16, 32, 32, deflate_slow},
{8, 16, 128, 128, deflate_slow},
{8, 32, 128, 256, deflate_slow},
{32, 128, 258, 1024, deflate_slow},
{32, 258, 258, 4096, deflate_slow}}
deflate_stored
block_state deflate_stored(deflate_state *s, int flush)
Definition: deflate.c:1690
deflate_fast
block_state deflate_fast(deflate_state *s, int flush)
Definition: deflate.c:1877
deflate_slow
block_state deflate_slow(deflate_state *s, int flush)
Definition: deflate.c:1979

Definition at line 128 of file deflate.c.

Referenced by deflate(), deflateParams(), and lm_init().

## ◆ deflate_copyright

const char deflate_copyright[]

Initial value:
=
" deflate 1.2.13 Copyright 1995-2022 Jean-loup Gailly and Mark Adler "

Definition at line 54 of file deflate.c.